<html>
<head>
<title>OGRE: OgreVertexIndexData.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgreVertexIndexData.h</h1><a href="OgreVertexIndexData_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __VertexIndexData_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __VertexIndexData_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include "<a class="code" href="OgreHardwareVertexBuffer_8h.html">OgreHardwareVertexBuffer.h</a>"</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include "<a class="code" href="OgreHardwareIndexBuffer_8h.html">OgreHardwareIndexBuffer.h</a>"</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>Ogre {
<a name="l00037"></a>00037     
<a name="l00039"></a><a class="code" href="namespaceOgre.html#defdc0dd104d75039087a1e50eb84773">00039</a>     <span class="keyword">typedef</span> std::vector&lt;HardwareBuffer::Usage&gt; <a class="code" href="namespaceOgre.html#defdc0dd104d75039087a1e50eb84773" title="Define a list of usage flags.">BufferUsageList</a>;
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 
<a name="l00043"></a><a class="code" href="classOgre_1_1VertexData.html">00043</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>
<a name="l00044"></a>00044     {
<a name="l00045"></a>00045     <span class="keyword">private</span>:
<a name="l00047"></a>00047         <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>&amp; rhs); <span class="comment">/* do nothing, should not use */</span>
<a name="l00049"></a>00049         <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>&amp; operator=(<span class="keyword">const</span> <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>&amp; rhs); <span class="comment">/* do not use */</span>
<a name="l00050"></a>00050     <span class="keyword">public</span>:
<a name="l00051"></a>00051         <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>();
<a name="l00052"></a>00052         ~<a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>();
<a name="l00053"></a>00053 
<a name="l00057"></a><a class="code" href="classOgre_1_1VertexData.html#bac9cde9c001b97cf1fea7fd05b79cf4">00057</a>         <a class="code" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to...">VertexDeclaration</a>* vertexDeclaration;
<a name="l00061"></a><a class="code" href="classOgre_1_1VertexData.html#1cf7dacb2a133d71620abd59cb3180b0">00061</a>         <a class="code" href="classOgre_1_1VertexBufferBinding.html" title="Records the state of all the vertex buffer bindings required to provide a vertex...">VertexBufferBinding</a>* vertexBufferBinding;
<a name="l00063"></a><a class="code" href="classOgre_1_1VertexData.html#a3dca90128a99a8cdcd68201ad2c2f93">00063</a>         <span class="keywordtype">size_t</span> vertexStart;
<a name="l00065"></a><a class="code" href="classOgre_1_1VertexData.html#0b59b63cc2dbede1c5fc6a932fd2c10d">00065</a>         <span class="keywordtype">size_t</span> vertexCount;
<a name="l00066"></a>00066 
<a name="l00067"></a>00067 
<a name="l00069"></a><a class="code" href="structOgre_1_1VertexData_1_1HardwareAnimationData.html">00069</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1VertexData_1_1HardwareAnimationData.html" title="Struct used to hold hardware morph / pose vertex data information.">HardwareAnimationData</a>
<a name="l00070"></a>00070         {
<a name="l00071"></a><a class="code" href="structOgre_1_1VertexData_1_1HardwareAnimationData.html#b9b4d7352c1007e75e944f499bb641ae">00071</a>             <span class="keyword">const</span> <a class="code" href="classOgre_1_1VertexElement.html" title="This class declares the usage of a single vertex buffer as a component of a complete...">VertexElement</a>* targetVertexElement;
<a name="l00072"></a><a class="code" href="structOgre_1_1VertexData_1_1HardwareAnimationData.html#3ebd1f099d030853fd1ac0fc2f50abb9">00072</a>             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> parametric;
<a name="l00073"></a>00073         };
<a name="l00074"></a><a class="code" href="classOgre_1_1VertexData.html#9b0be9ce516c0b04e3565317e6186b15">00074</a>         <span class="keyword">typedef</span> std::vector&lt;HardwareAnimationData&gt; HardwareAnimationDataList;
<a name="l00076"></a><a class="code" href="classOgre_1_1VertexData.html#43acb3f735c2d4bdfdfbfdebc26dc52e">00076</a>         HardwareAnimationDataList hwAnimationDataList;
<a name="l00078"></a><a class="code" href="classOgre_1_1VertexData.html#f24c57003d9fa3d717ca16e7f5becb41">00078</a>         <span class="keywordtype">size_t</span> hwAnimDataItemsUsed;
<a name="l00079"></a>00079         
<a name="l00083"></a>00083         <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* clone(<span class="keywordtype">bool</span> copyData = <span class="keyword">true</span>) <span class="keyword">const</span>;
<a name="l00084"></a>00084 
<a name="l00104"></a>00104         <span class="keywordtype">void</span> prepareForShadowVolume(<span class="keywordtype">void</span>);
<a name="l00105"></a>00105 
<a name="l00119"></a><a class="code" href="classOgre_1_1VertexData.html#154124cc2848e3eae62e9d508f45e921">00119</a>         <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a> hardwareShadowVolWBuffer;
<a name="l00120"></a>00120 
<a name="l00121"></a>00121 
<a name="l00138"></a>00138         <span class="keywordtype">void</span> reorganiseBuffers(<a class="code" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to...">VertexDeclaration</a>* newDeclaration, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#defdc0dd104d75039087a1e50eb84773" title="Define a list of usage flags.">BufferUsageList</a>&amp; bufferUsage);
<a name="l00139"></a>00139 
<a name="l00155"></a>00155         <span class="keywordtype">void</span> reorganiseBuffers(<a class="code" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to...">VertexDeclaration</a>* newDeclaration);
<a name="l00156"></a>00156 
<a name="l00166"></a>00166         <span class="keywordtype">void</span> closeGapsInBindings(<span class="keywordtype">void</span>);
<a name="l00167"></a>00167 
<a name="l00176"></a>00176         <span class="keywordtype">void</span> removeUnusedBuffers(<span class="keywordtype">void</span>);
<a name="l00177"></a>00177 
<a name="l00185"></a>00185         <span class="keywordtype">void</span> convertPackedColour(<a class="code" href="namespaceOgre.html#027109503a988ba85f4c63b55082907f" title="Vertex element type, used to identify the base types of the vertex contents.">VertexElementType</a> srcType, <a class="code" href="namespaceOgre.html#027109503a988ba85f4c63b55082907f" title="Vertex element type, used to identify the base types of the vertex contents.">VertexElementType</a> destType);
<a name="l00186"></a>00186 
<a name="l00187"></a>00187 
<a name="l00201"></a>00201         <span class="keywordtype">void</span> allocateHardwareAnimationElements(<a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> count);
<a name="l00202"></a>00202 
<a name="l00203"></a>00203 
<a name="l00204"></a>00204 
<a name="l00205"></a>00205     };
<a name="l00206"></a>00206 
<a name="l00208"></a><a class="code" href="classOgre_1_1IndexData.html">00208</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1IndexData.html" title="Summary class collecting together index data source information.">IndexData</a> 
<a name="l00209"></a>00209     {
<a name="l00210"></a>00210     <span class="keyword">protected</span>:
<a name="l00212"></a>00212         <a class="code" href="classOgre_1_1IndexData.html" title="Summary class collecting together index data source information.">IndexData</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1IndexData.html" title="Summary class collecting together index data source information.">IndexData</a>&amp; rhs); <span class="comment">/* do nothing, should not use */</span>
<a name="l00214"></a>00214         <a class="code" href="classOgre_1_1IndexData.html" title="Summary class collecting together index data source information.">IndexData</a>&amp; operator=(<span class="keyword">const</span> <a class="code" href="classOgre_1_1IndexData.html" title="Summary class collecting together index data source information.">IndexData</a>&amp; rhs); <span class="comment">/* do not use */</span>
<a name="l00215"></a>00215     <span class="keyword">public</span>:
<a name="l00216"></a>00216         <a class="code" href="classOgre_1_1IndexData.html" title="Summary class collecting together index data source information.">IndexData</a>();
<a name="l00217"></a>00217         ~<a class="code" href="classOgre_1_1IndexData.html" title="Summary class collecting together index data source information.">IndexData</a>();
<a name="l00219"></a><a class="code" href="classOgre_1_1IndexData.html#1a9f241fbc57ce4cce5615302da71b76">00219</a>         <a class="code" href="classOgre_1_1HardwareIndexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareIndexBufferSharedPtr</a> indexBuffer;
<a name="l00220"></a>00220 
<a name="l00222"></a><a class="code" href="classOgre_1_1IndexData.html#7cd3d6f7d4af3271bfae8ce49f46ff3a">00222</a>         <span class="keywordtype">size_t</span> indexStart;
<a name="l00223"></a>00223 
<a name="l00225"></a><a class="code" href="classOgre_1_1IndexData.html#fad8ae9cec6cab5c8c07ee5532dd89c5">00225</a>         <span class="keywordtype">size_t</span> indexCount;
<a name="l00226"></a>00226 
<a name="l00230"></a>00230         <a class="code" href="classOgre_1_1IndexData.html" title="Summary class collecting together index data source information.">IndexData</a>* clone(<span class="keywordtype">bool</span> copyData = <span class="keyword">true</span>) <span class="keyword">const</span>;
<a name="l00231"></a>00231 
<a name="l00240"></a>00240         <span class="keywordtype">void</span> optimiseVertexCacheTriList(<span class="keywordtype">void</span>);
<a name="l00241"></a>00241     
<a name="l00242"></a>00242     };
<a name="l00243"></a>00243 
<a name="l00249"></a><a class="code" href="classOgre_1_1VertexCacheProfiler.html">00249</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1VertexCacheProfiler.html" title="Vertex cache profiler.">VertexCacheProfiler</a>
<a name="l00250"></a>00250     {
<a name="l00251"></a>00251         <span class="keyword">public</span>:
<a name="l00252"></a><a class="code" href="classOgre_1_1VertexCacheProfiler.html#4b9f6e1bc8dd4f2030f5a11c6e3dfbb9">00252</a>             <span class="keyword">enum</span> <a class="code" href="classOgre_1_1VertexCacheProfiler.html#4b9f6e1bc8dd4f2030f5a11c6e3dfbb9">CacheType</a> {
<a name="l00253"></a><a class="code" href="classOgre_1_1VertexCacheProfiler.html#4b9f6e1bc8dd4f2030f5a11c6e3dfbb9d0fb7b7d84385dee76ad77538bb50acc">00253</a>                 FIFO, LRU
<a name="l00254"></a>00254             };
<a name="l00255"></a>00255 
<a name="l00256"></a><a class="code" href="classOgre_1_1VertexCacheProfiler.html#967ec965713da4ce36c461e847f964f9">00256</a>             <a class="code" href="classOgre_1_1VertexCacheProfiler.html" title="Vertex cache profiler.">VertexCacheProfiler</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cachesize = 16, <a class="code" href="classOgre_1_1VertexCacheProfiler.html#4b9f6e1bc8dd4f2030f5a11c6e3dfbb9">CacheType</a> cachetype = FIFO )
<a name="l00257"></a>00257                 : size ( cachesize ), type ( cachetype ), tail (0), buffersize (0), hit (0), miss (0)
<a name="l00258"></a>00258             {
<a name="l00259"></a>00259                 cache = <span class="keyword">new</span> <a class="code" href="namespaceOgre.html#df2a0cf2e77143b5ee1d38a75e289545">uint32</a>[size];
<a name="l00260"></a>00260             };
<a name="l00261"></a>00261 
<a name="l00262"></a><a class="code" href="classOgre_1_1VertexCacheProfiler.html#6ab7499e2083ad5f35f34a816806cef8">00262</a>             ~<a class="code" href="classOgre_1_1VertexCacheProfiler.html" title="Vertex cache profiler.">VertexCacheProfiler</a>()
<a name="l00263"></a>00263             {
<a name="l00264"></a>00264                 <span class="keyword">delete</span>[] cache;
<a name="l00265"></a>00265             }
<a name="l00266"></a>00266 
<a name="l00267"></a>00267             <span class="keywordtype">void</span> profile(<span class="keyword">const</span> <a class="code" href="classOgre_1_1HardwareIndexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareIndexBufferSharedPtr</a>&amp; indexBuffer);
<a name="l00268"></a><a class="code" href="classOgre_1_1VertexCacheProfiler.html#73303582f428106fc0b3177d11984228">00268</a>             <span class="keywordtype">void</span> reset() { hit = 0; miss = 0; tail = 0; buffersize = 0; };
<a name="l00269"></a><a class="code" href="classOgre_1_1VertexCacheProfiler.html#a8578416f0d313a75d39a30c5d47123a">00269</a>             <span class="keywordtype">void</span> flush() { tail = 0; buffersize = 0; };
<a name="l00270"></a>00270 
<a name="l00271"></a><a class="code" href="classOgre_1_1VertexCacheProfiler.html#9f0a043c69c3b8f472cdff618bccc624">00271</a>             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> getHits() { <span class="keywordflow">return</span> hit; };
<a name="l00272"></a><a class="code" href="classOgre_1_1VertexCacheProfiler.html#4b6ea00ce8ef7a1d1d8676b98cd2c128">00272</a>             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> getMisses() { <span class="keywordflow">return</span> miss; };
<a name="l00273"></a><a class="code" href="classOgre_1_1VertexCacheProfiler.html#dc56faf57c63b1d1df6bb2f09892b3b5">00273</a>             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> getSize() { <span class="keywordflow">return</span> size; };
<a name="l00274"></a>00274         <span class="keyword">private</span>:
<a name="l00275"></a>00275             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> size;
<a name="l00276"></a><a class="code" href="classOgre_1_1VertexCacheProfiler.html#d72231fffc5f97675058ebe22bdbba27">00276</a>             <a class="code" href="namespaceOgre.html#df2a0cf2e77143b5ee1d38a75e289545">uint32</a> *cache;
<a name="l00277"></a><a class="code" href="classOgre_1_1VertexCacheProfiler.html#fb8e69a97d30c33f8ba37abe54522110">00277</a>             <a class="code" href="classOgre_1_1VertexCacheProfiler.html#4b9f6e1bc8dd4f2030f5a11c6e3dfbb9">CacheType</a> type;
<a name="l00278"></a>00278 
<a name="l00279"></a><a class="code" href="classOgre_1_1VertexCacheProfiler.html#35553327f48981689555cc00eb97d339">00279</a>             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> tail, buffersize;
<a name="l00280"></a><a class="code" href="classOgre_1_1VertexCacheProfiler.html#409b41e6232966ea68bdf0c7273eefb0">00280</a>             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> hit, miss;
<a name="l00281"></a>00281 
<a name="l00282"></a>00282             <span class="keywordtype">bool</span> inCache(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index);
<a name="l00283"></a>00283     };
<a name="l00284"></a>00284 }
<a name="l00285"></a>00285 <span class="preprocessor">#endif</span>
<a name="l00286"></a>00286 <span class="preprocessor"></span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:57 2008
</p>
</body>
</html>
